unit Ukjolay;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Kjolay, StdCtrls, Tabs, Buttons, Spin;

type
  TfrmKJOlayDemo = class(TForm)
    TabSet1: TTabSet;
    Notebook1: TNotebook;
    pnlMain: TPanel;
    kjoMain: TKJOLAY;
    pnlOverlay: TPanel;
    kjoDisplay: TKJOLAY;
    lblOverlay: TLabel;
    lblMain: TLabel;
    spdUp: TSpeedButton;
    spdDown: TSpeedButton;
    spdRight: TSpeedButton;
    spdLeft: TSpeedButton;
    OpenDialog1: TOpenDialog;
    spdOpenOverlay: TSpeedButton;
    spdOpenMain: TSpeedButton;
    spdPaste: TSpeedButton;
    cbxAutoRefresh: TCheckBox;
    cbxBufferImage: TCheckBox;
    spdRefresh: TSpeedButton;
    sedIncX: TSpinEdit;
    lblIncX: TLabel;
    sedIncY: TSpinEdit;
    lblIncY: TLabel;
    kjoOverlay: TKJOLAY;
    spdResetBuffer: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TabSet1Click(Sender: TObject);
    procedure spdLeftClick(Sender: TObject);
    procedure spdOpenOverlayClick(Sender: TObject);
    procedure spdOpenMainClick(Sender: TObject);
    procedure spdPasteClick(Sender: TObject);
    procedure spdUpClick(Sender: TObject);
    procedure spdRightClick(Sender: TObject);
    procedure spdDownClick(Sender: TObject);
    procedure cbxBufferImageClick(Sender: TObject);
    procedure cbxAutoRefreshClick(Sender: TObject);
    procedure spdRefreshClick(Sender: TObject);
    procedure spdResetBufferClick(Sender: TObject);
  private
    { Private declarations }
    CurrX, CurrY: Integer;
    procedure ChangeArrowState(AState: Boolean);
  public
    { Public declarations }
  end;

var
  frmKJOlayDemo: TfrmKJOlayDemo;

implementation

{$R *.DFM}

const MAIN_HEIGHT = 237;
      MAIN_WIDTH = 277;
      OVERLAY_HEIGHT = 110;
      OVERLAY_WIDTH = 125;

procedure TfrmKJOlayDemo.FormCreate(Sender: TObject);
  var AHDC: HDC; AHandle: THandle; BitsPerPixel: Integer;
      Msg1, Msg2, Msg3, Msg4: String;
begin
  CurrX:=0;
  CurrY:=0;
  Tabset1.Tabs:=Notebook1.Pages;

  AHandle:=Application.Handle;
  AHDC:=GetDeviceContext(AHandle);
  BitsPerPixel:=GetDeviceCaps(AHDC, BITSPIXEL);

  Msg1:='"K&&J Olay" will not work properly in 256 color mode.'+#13;
  Msg2:='Please increase the color depth of your video driver'+#13;
  Msg3:='before using the "K&&J Olay" component or demo application.'+#13+#13;
  Msg4:='See "ReadMe.Txt" for more help.';

  if BitsPerPixel = 8 then
    MessageDlg(Msg1+Msg2+Msg3+Msg4, mtWarning, [mbOK], 0);
end;

procedure TfrmKJOlayDemo.TabSet1Click(Sender: TObject);
begin
  Notebook1.PageIndex:=Tabset1.TabIndex;
end;

procedure TfrmKJOlayDemo.spdLeftClick(Sender: TObject);
begin
  CurrX:=CurrX-sedIncX.Value;
  kjoMain.KJDrawTransBitmap(kjoOverlay, CurrX, CurrY);
end;

procedure TfrmKJOlayDemo.spdOpenOverlayClick(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    kjoDisplay.Picture.LoadFromFile(OpenDialog1.FileName);
    if kjoDisplay.Height > OVERLAY_HEIGHT then
      kjoDisplay.Height:=OVERLAY_HEIGHT;
    if kjoDisplay.Width > OVERLAY_WIDTH then
      kjoDisplay.Width:=OVERLAY_WIDTH;
    kjoMain.KJResetBuffer;
  end;
end;

procedure TfrmKJOlayDemo.spdOpenMainClick(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    kjoMain.Picture.LoadFromFile(OpenDialog1.FileName);
    if kjoMain.Height > MAIN_HEIGHT then
      kjoMain.Height:=MAIN_HEIGHT;
    if kjoMain.Width > MAIN_WIDTH then
      kjoMain.Width:=MAIN_WIDTH;
    ChangeArrowState(False);
    kjoMain.KJResetBuffer;
    CurrX:=0;
    CurrY:=0;
  end;
end;

procedure TfrmKJOlayDemo.ChangeArrowState(AState: Boolean);
begin
  spdLeft.Enabled:=AState;
  spdRight.Enabled:=AState;
  spdUp.Enabled:=AState;
  spdDown.Enabled:=AState;
end;

procedure TfrmKJOlayDemo.spdPasteClick(Sender: TObject);
begin
   kjoOverlay.Picture.Bitmap.Assign(kjoDisplay.Picture.Bitmap);
   kjoMain.KJDrawTransBitmap(kjoOverlay, 0, 0);
   ChangeArrowState(True);
   CurrX:=0;
   CurrY:=0;
end;

procedure TfrmKJOlayDemo.spdUpClick(Sender: TObject);
begin
  CurrY:=CurrY-sedIncY.Value;
  kjoMain.KJDrawTransBitmap(kjoOverlay, CurrX, CurrY);
end;

procedure TfrmKJOlayDemo.spdRightClick(Sender: TObject);
begin
  CurrX:=CurrX+sedIncX.Value;
  kjoMain.KJDrawTransBitmap(kjoOverlay, CurrX, CurrY);
end;

procedure TfrmKJOlayDemo.spdDownClick(Sender: TObject);
begin
  CurrY:=CurrY+sedIncY.Value;
  kjoMain.KJDrawTransBitmap(kjoOverlay, CurrX, CurrY);
end;

procedure TfrmKJOlayDemo.cbxBufferImageClick(Sender: TObject);
begin
  kjoMain.KJBufferImage:=cbxBufferImage.Checked;
end;

procedure TfrmKJOlayDemo.cbxAutoRefreshClick(Sender: TObject);
begin
  kjoMain.KJAutoRefresh:=cbxAutoRefresh.Checked;
end;

procedure TfrmKJOlayDemo.spdRefreshClick(Sender: TObject);
begin
  kjoMain.Refresh;
end;

procedure TfrmKJOlayDemo.spdResetBufferClick(Sender: TObject);
begin
  kjoMain.KJResetBuffer;
end;

end.
